


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: TimeEntryService</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.service</a> ]
</div>

<h1>Coverage Summary for Class: TimeEntryService (com.dema.timeregistration.service)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">TimeEntryService</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    71.4%
  </span>
  <span class="absValue">
    (5/ 7)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    81.4%
  </span>
  <span class="absValue">
    (57/ 70)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.service;
<i>2</i>&nbsp;
<i>3</i>&nbsp;
<i>4</i>&nbsp;import com.dema.timeregistration.Utils;
<i>5</i>&nbsp;import com.dema.timeregistration.entity.Task;
<i>6</i>&nbsp;import com.dema.timeregistration.entity.TimeEntry;
<i>7</i>&nbsp;import com.dema.timeregistration.entity.User;
<i>8</i>&nbsp;import com.dema.timeregistration.entity.UserProjectBooking;
<i>9</i>&nbsp;import com.dema.timeregistration.repository.TaskRepository;
<i>10</i>&nbsp;import com.dema.timeregistration.repository.UserRepository;
<i>11</i>&nbsp;import com.dema.timeregistration.service.exception.AccessDeniedException;
<i>12</i>&nbsp;import com.dema.timeregistration.service.exception.EntityAlreadyExistsException;
<i>13</i>&nbsp;import com.dema.timeregistration.service.exception.EntityNotFoundException;
<i>14</i>&nbsp;import com.dema.timeregistration.service.models.RegisterTimeEntryRequest;
<i>15</i>&nbsp;import com.dema.timeregistration.service.models.UpdateTimeEntryRequest;
<i>16</i>&nbsp;
<i>17</i>&nbsp;import java.sql.Date;
<i>18</i>&nbsp;import java.text.ParseException;
<i>19</i>&nbsp;import java.time.Instant;
<i>20</i>&nbsp;import java.util.Comparator;
<i>21</i>&nbsp;import java.util.Optional;
<i>22</i>&nbsp;import java.util.stream.Collectors;
<i>23</i>&nbsp;
<i>24</i>&nbsp;public class TimeEntryService {
<i>25</i>&nbsp;    private final UserRepository userRepository;
<i>26</i>&nbsp;    private final TaskRepository taskRepository;
<i>27</i>&nbsp;
<b class="fc"><i>28</i>&nbsp;    public TimeEntryService(UserRepository userRepository, TaskRepository taskRepository) {</b>
<b class="fc"><i>29</i>&nbsp;        this.userRepository = userRepository;</b>
<b class="fc"><i>30</i>&nbsp;        this.taskRepository = taskRepository;</b>
<b class="fc"><i>31</i>&nbsp;    }</b>
<i>32</i>&nbsp;
<i>33</i>&nbsp;    public void registerTimeEntry(RegisterTimeEntryRequest request, UserContext userContext) throws EntityNotFoundException, ParseException, AccessDeniedException, EntityAlreadyExistsException {
<b class="fc"><i>34</i>&nbsp;        User user = userRepository.findById(userContext.getUser().getId()).orElseThrow(IllegalStateException::new);</b>
<b class="fc"><i>35</i>&nbsp;        Task task = taskRepository.findById(request.getTaskId()).orElseThrow(EntityNotFoundException::taskNotFound);</b>
<i>36</i>&nbsp;
<b class="fc"><i>37</i>&nbsp;        Instant startTime = Utils.getDateFormat().parse(request.getStartTime()).toInstant();</b>
<b class="fc"><i>38</i>&nbsp;        Instant endTime = Utils.getDateFormat().parse(request.getEndTime()).toInstant();</b>
<i>39</i>&nbsp;
<b class="fc"><i>40</i>&nbsp;        if (endTime.isBefore(startTime)) {</b>
<b class="nc"><i>41</i>&nbsp;            throw new IllegalArgumentException(&quot;The specified end time is before the start time&quot;);</b>
<i>42</i>&nbsp;        }
<i>43</i>&nbsp;
<b class="fc"><i>44</i>&nbsp;        Optional&lt;UserProjectBooking&gt; projectBookingOptional = user.getUserProjectBookings().stream()</b>
<b class="fc"><i>45</i>&nbsp;                .filter(pb -&gt; pb.getProject().equals(task.getProject()) &amp;&amp; (pb.getStartTime().isBefore(startTime) || pb.getStartTime().equals(startTime)) &amp;&amp; (pb.getEndTime().isAfter(endTime) || pb.getEndTime().equals(endTime)))</b>
<b class="fc"><i>46</i>&nbsp;                .findFirst();</b>
<i>47</i>&nbsp;
<b class="fc"><i>48</i>&nbsp;        if (!projectBookingOptional.isPresent()) {</b>
<b class="fc"><i>49</i>&nbsp;            throw new AccessDeniedException(&quot;The time entry is not in a period where the user has been booked to the project &#39;&quot; + task.getProject().getName() + &quot;&#39;&quot;);</b>
<i>50</i>&nbsp;        }
<i>51</i>&nbsp;
<b class="fc"><i>52</i>&nbsp;        Optional&lt;TimeEntry&gt; alreadyTakenOptional = projectBookingOptional.get().getTimeEntries()</b>
<b class="fc"><i>53</i>&nbsp;                .stream()</b>
<b class="fc"><i>54</i>&nbsp;                .filter(te -&gt; te.getUserProjectBooking().getUser().equals(user))</b>
<b class="fc"><i>55</i>&nbsp;                .filter(te -&gt; Utils.doTimeIntervalsOverlap(te.getStartTime(), te.getEndTime(), startTime, endTime))</b>
<b class="fc"><i>56</i>&nbsp;                .findFirst();</b>
<i>57</i>&nbsp;
<b class="fc"><i>58</i>&nbsp;        if (alreadyTakenOptional.isPresent()) {</b>
<b class="fc"><i>59</i>&nbsp;            throw getOverlapsException(alreadyTakenOptional.get());</b>
<i>60</i>&nbsp;        }
<i>61</i>&nbsp;
<b class="fc"><i>62</i>&nbsp;        TimeEntry timeEntry = TimeEntry.create(task, projectBookingOptional.get(), startTime, endTime);</b>
<b class="fc"><i>63</i>&nbsp;        projectBookingOptional.get().getTimeEntries().add(timeEntry);</b>
<b class="fc"><i>64</i>&nbsp;        userRepository.save(user);</b>
<b class="fc"><i>65</i>&nbsp;    }</b>
<i>66</i>&nbsp;
<i>67</i>&nbsp;    public void updateTimeEntry(UpdateTimeEntryRequest request, UserContext userContext) throws EntityNotFoundException, ParseException, EntityAlreadyExistsException, AccessDeniedException {
<b class="fc"><i>68</i>&nbsp;        User user = userRepository.findById(userContext.getUser().getId()).orElseThrow(IllegalStateException::new);</b>
<b class="fc"><i>69</i>&nbsp;        Task task = taskRepository.findById(request.getTaskId()).orElseThrow(EntityNotFoundException::taskNotFound);</b>
<i>70</i>&nbsp;
<b class="fc"><i>71</i>&nbsp;        Instant origStartTime = Utils.getDateFormat().parse(request.getOriginalStartTime()).toInstant();</b>
<i>72</i>&nbsp;
<b class="fc"><i>73</i>&nbsp;        UserProjectBooking projectBooking = user.getUserProjectBookings().stream()</b>
<b class="fc"><i>74</i>&nbsp;                .filter(pb -&gt; pb.getProject().equals(task.getProject()) &amp;&amp;</b>
<b class="fc"><i>75</i>&nbsp;                        (pb.getStartTime().isBefore(origStartTime) || pb.getStartTime().equals(origStartTime)) &amp;&amp; (pb.getEndTime().isAfter(origStartTime)))</b>
<b class="fc"><i>76</i>&nbsp;                .findFirst().orElseThrow(EntityNotFoundException::projectNotFound);</b>
<i>77</i>&nbsp;
<i>78</i>&nbsp;
<b class="fc"><i>79</i>&nbsp;        TimeEntry timeEntry = projectBooking.getTimeEntries()</b>
<b class="fc"><i>80</i>&nbsp;                .stream()</b>
<b class="fc"><i>81</i>&nbsp;                .filter(te -&gt; te.getStartTime().equals(origStartTime))</b>
<b class="fc"><i>82</i>&nbsp;                .findFirst().orElseThrow(() -&gt; new EntityNotFoundException(&quot;The specified time entry could not be found&quot;));</b>
<i>83</i>&nbsp;
<b class="fc"><i>84</i>&nbsp;        if (timeEntry.getStartTime() != null) {</b>
<b class="fc"><i>85</i>&nbsp;            Instant startTime = Utils.getDateFormat().parse(request.getStartTime()).toInstant();</b>
<b class="fc"><i>86</i>&nbsp;            timeEntry.setStartTime(startTime);</b>
<i>87</i>&nbsp;        }
<i>88</i>&nbsp;
<b class="fc"><i>89</i>&nbsp;        if (timeEntry.getEndTime() != null) {</b>
<b class="fc"><i>90</i>&nbsp;            Instant endTime = Utils.getDateFormat().parse(request.getEndTime()).toInstant();</b>
<b class="fc"><i>91</i>&nbsp;            timeEntry.setEndTime(endTime);</b>
<i>92</i>&nbsp;        }
<i>93</i>&nbsp;
<b class="fc"><i>94</i>&nbsp;        Optional&lt;TimeEntry&gt; alreadyTakenOptional = timeEntry.getUserProjectBooking().getTimeEntries()</b>
<b class="fc"><i>95</i>&nbsp;                .stream()</b>
<b class="fc"><i>96</i>&nbsp;                .filter(te -&gt; te.getUserProjectBooking().getUser().equals(user))</b>
<b class="fc"><i>97</i>&nbsp;                .filter(te -&gt; Utils.doTimeIntervalsOverlap(te.getStartTime(), te.getEndTime(), timeEntry.getStartTime(), timeEntry.getEndTime()) &amp;&amp; !te.equals(timeEntry))</b>
<b class="fc"><i>98</i>&nbsp;                .findFirst();</b>
<i>99</i>&nbsp;
<b class="fc"><i>100</i>&nbsp;        if (alreadyTakenOptional.isPresent()) {</b>
<b class="fc"><i>101</i>&nbsp;            throw getOverlapsException(alreadyTakenOptional.get());</b>
<i>102</i>&nbsp;        }
<i>103</i>&nbsp;
<b class="fc"><i>104</i>&nbsp;        if (!((projectBooking.getStartTime().isBefore(timeEntry.getStartTime()) || projectBooking.getStartTime().equals(timeEntry.getStartTime())) &amp;&amp; (projectBooking.getEndTime().isAfter(timeEntry.getEndTime()) || projectBooking.getEndTime().equals(timeEntry.getEndTime())))) {</b>
<b class="fc"><i>105</i>&nbsp;            throw new AccessDeniedException(&quot;The time entry must be within the project booking&quot;);</b>
<i>106</i>&nbsp;        }
<b class="fc"><i>107</i>&nbsp;        userRepository.save(user);</b>
<b class="fc"><i>108</i>&nbsp;    }</b>
<i>109</i>&nbsp;
<i>110</i>&nbsp;    public EntityAlreadyExistsException getOverlapsException(TimeEntry alreadyTaken) throws EntityAlreadyExistsException {
<b class="fc"><i>111</i>&nbsp;        String startTimeString = Utils.getDateFormat().format(Date.from(alreadyTaken.getStartTime()));</b>
<b class="fc"><i>112</i>&nbsp;        String endTimeString = Utils.getDateFormat().format(Date.from(alreadyTaken.getEndTime()));</b>
<i>113</i>&nbsp;
<b class="fc"><i>114</i>&nbsp;        throw new EntityAlreadyExistsException(&quot;The requested time entry overlaps with another Time Entry (&quot; +</b>
<i>115</i>&nbsp;                startTimeString + &quot; to &quot; + endTimeString
<b class="fc"><i>116</i>&nbsp;                + &quot; for task &#39;&quot; + alreadyTaken.getTask().getName() + &quot;&#39;)&quot;);</b>
<i>117</i>&nbsp;    }
<i>118</i>&nbsp;
<i>119</i>&nbsp;    public String listTimeEntries(String fromTime, String toTime, UserContext userContext) throws ParseException, EntityNotFoundException {
<b class="nc"><i>120</i>&nbsp;        Instant from = Utils.getDateFormat().parse(fromTime).toInstant();</b>
<b class="nc"><i>121</i>&nbsp;        Instant to = Utils.getDateFormat().parse(toTime).toInstant();</b>
<i>122</i>&nbsp;
<b class="nc"><i>123</i>&nbsp;        User user = userRepository.findById(userContext.getUser().getId()).orElseThrow(EntityNotFoundException::userNotFound);</b>
<i>124</i>&nbsp;
<b class="nc"><i>125</i>&nbsp;        return user.getUserProjectBookings().stream()</b>
<b class="nc"><i>126</i>&nbsp;                .flatMap(pb -&gt; pb.getTimeEntries().stream())</b>
<b class="nc"><i>127</i>&nbsp;                .filter(te -&gt; te.getStartTime().isAfter(from) &amp;&amp; te.getEndTime().isBefore(to))</b>
<b class="nc"><i>128</i>&nbsp;                .sorted(Comparator.comparing(TimeEntry::getStartTime))</b>
<b class="nc"><i>129</i>&nbsp;                .map(te -&gt; {</b>
<b class="nc"><i>130</i>&nbsp;                    String startTimeString = Utils.getDateFormat().format(Date.from(te.getStartTime()));</b>
<b class="nc"><i>131</i>&nbsp;                    String endTimeString = Utils.getDateFormat().format(Date.from(te.getEndTime()));</b>
<i>132</i>&nbsp;
<b class="nc"><i>133</i>&nbsp;                    return te.getTask().getName() + &quot; - &quot; + startTimeString + &quot; to &quot; + endTimeString;</b>
<b class="nc"><i>134</i>&nbsp;                }).collect(Collectors.joining(&quot;\n&quot;));</b>
<i>135</i>&nbsp;    }
<i>136</i>&nbsp;}
<i>137</i>&nbsp;
<i>138</i>&nbsp;
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
